Subject: Re: [MMUSIC] Implementation specific comments on "draft-ietf-mmusic-sdpng-04"

From: Teodora Guenkova <[email-masked]>
Date: Wed, 29 May 2002 15:09:51 +0200

Dear Dirk,
I forgot yesterday to mention, why we changed the XML-schema
of the 'Session' element. I only explained the problem with
the multiple "transport"-s. Read below also the additional
explanation.

"
.......................................................
>     Teodora> 6. Comments on the RTP-Profile definition within the SDPng XML-Schema
.......................................................... 
>     Teodora> - Define element <rtp:udp> in RTP Profile as follows:
> 
>     Teodora> <xsd:element name="udp" type="rtp:UDP"
>     Teodora> substitutionGroup="rtp:transport"/>
> 
>     Teodora> - Define <rtp:transport> globally in RTP Profile:
> 
>     Teodora> <xsd:element name="transport" type="rtp:Transport"
>     Teodora> substitutionGroup="sdpng:d"/>
> 
..........................................................
Dirk > Yup, I will change the Schema XML-definition accordingly.
...........................................................
>     Teodora> 6.2 Possible solution
> 
>     Teodora> Definition of complexType Session (RTP Profile) is as follows:
> 
>     Teodora> <xsd:complexType name="Session" mixed="false">
>     Teodora>        <xsd:complexContent mixed="false">
>     Teodora>          <xsd:extension base="sdpng:SessionConfig">
>     Teodora>         <xsd:sequence>
>     Teodora>          <xsd:element ref="rtp:udp" minOccurs="0"/>
>     Teodora>         </xsd:sequence>
>     Teodora>         <xsd:attribute name="format" type="xsd:string"/>
>     Teodora>          </xsd:extension>
>     Teodora>        </xsd:complexContent>
>     Teodora>      </xsd:complexType>
> 
............................................................. 
Dirk > Isn't it sufficient to change the defintion of 'rtp:udp' and
Dirk > 'rtp:transport' as you proposed and leave the definition of
'Session'
Dirk > as is, i.e., require an element of type 'rtp:transport'?

We were considering the examples on pages 21 to 28 of the Draft, where
the <def> element includes <rtp:udp>-element and also the usage of the
<transport> element as an attribute. 
Of course you can leave the 'Session' definition as it is, but then you
have to consider how to uniquely define a <transport> as attribute,
since having both element and attribute with the same name makes the XML
hard to interpret, especially by using SAX parsers and generating custom
objects by hand. Here I do not mean that the parsers make mistakes but
that the implementers do so and having an unique definition would make
the life of the implementers easier.
Additionally, if not having a global <transport> element definition, you 
should consider an additional local one for <def>, which can make the 
interpretation difficult as by having an attribute with the same name. 
Currently you have the <transport> element in the schema only as a 
leaf-element of the <session> element.
......................................................................
"

If you define the <transport> element globaly in the RTP-Profile,
this means it would be visible for the <def> element.
But if the <transport> element is an abstract one, you are
disallowed to reference it with "ref=". You can reference it with "ref="
only in one of its concrete forms, this means "rtp:udp". If you have
multiple instances of the <transport> you have to list them all
within the 'Session' element or at least those you need for the
'Session' element. This is at least what I know about the "ref="-s.

Regards,
	Teodora

-- 
-----------------------------------------
Teodora Guenkova-Luy
Dept. Distributed Systems, University of Ulm, 
Oberer Eselsberg, 89069 Ulm, Germany

Tel.: +49 (0731) 502-4148 
FAX: +49 (0731) 502-4142 

e-Mail: [email-masked] 
-----------------------------------------

_______________________________________________
mmusic mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/mmusic